﻿//  Copyright © Decebal Mihailescu 2013
//  All rights reserved. This source code and binaries are distributed under 
//  Microsoft Public License (Ms-PL)
//  The latest code is available at http://VSDesignPatterns.codeplex.com

//  Redistributions of source code must retain the above copyright notice, 
//  this list of conditions and the following disclaimer. 
//  Redistributions in binary form must reproduce the above copyright notice, 
//  this list of conditions and the following disclaimer in the documentation 
//  and/or other materials provided with the distribution. 

//  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
//  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
//  PURPOSE. IT CAN BE DISTRIBUTED FREE OF CHARGE AS LONG AS THIS HEADER 
//  REMAINS UNCHANGED.
using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;

namespace VSEmulator
{
    using DesignPatternsWizard;
    using System.ComponentModel;
    using System.IO;
    using Microsoft.Win32;

    static class Program
    {

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static int Main(string[] args)
        {
            //ProjectUtils.ShowModalDlg("It is recommended that you close\r\nVisual Studio before continuing!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            //return 1;
            /*
            dynamic shellApplication = Activator.CreateInstance(Type.GetTypeFromProgID("Shell.Application"));

            dynamic compressedFolderContents = shellApplication.NameSpace(@"C:\Sandbox\DesignPatterns\Misc\TemplateLibrary.zip").Items;

            if(!System.IO.Directory.Exists(@"c:\temp\unzip\"))
              System.IO.Directory.CreateDirectory(@"c:\temp\unzip\");
            dynamic destinationFolder = shellApplication.NameSpace(@"c:\temp\unzip\");
            destinationFolder.CopyHere(compressedFolderContents);

            if (args.Length == 0)
            {
                MessageBox.Show("You must give a project file as an arument!", "Missing Argument");
                return 1;
            }
            if(!File.Exists(args[0]))
            {
                MessageBox.Show("The file '" + args[0] +"' does not exists!", "Missing file");
                return -1;
            }
            */
            ProjectInfo prj = null;
            if (args.Length == 0)
            {
                prj = new ProjectInfo(CodeLangEnum.ManagedCpp);
                prj.FileName = @"C:\Sandbox\MultiProject\some filler";//args[0];//
            }
            else
            {
                IEnumerable<CodeLangEnum> langs = args.Select(a => a.ToLower()).Select(s =>
                    {
                        if (s.EndsWith(".csproj")) return CodeLangEnum.CSharp;
                        if (s.EndsWith(".vbproj")) return CodeLangEnum.VB;
                        if (s.EndsWith(".vcproj")) return CodeLangEnum.NativeCpp;
                        return CodeLangEnum.Unsupported;

                    });
                if (langs.All(l => l == CodeLangEnum.Unsupported))
                    prj = new ProjectInfo(CodeLangEnum.CSharp);// no project in args
                else
                    prj = new ProjectInfo(langs.First(l => l != CodeLangEnum.Unsupported));
                prj.FileName = args[0];

            }

            prj.ProjectName = Path.GetFileNameWithoutExtension(prj.FileName);// "CSharpProj";
            prj.ProjectProperties = new Dictionary<string, string>(1);
            prj.ProjectProperties.Add("DefaultNamespace", prj.ProjectName);
            prj.ProjectProperties.Add("RootNamespace", prj.ProjectName);
            prj.ProjectProperties.Add("keyword", "ManagedCProj");// make a managed CPP project
            if (prj.CodeLang == CodeLangEnum.NativeCpp)
                prj.CodeLang = CodeLangEnum.ManagedCpp;
            Application.EnableVisualStyles();

            WizardForm frm = new WizardForm(prj);
            frm.VSWindow = null;
            IWizardWindow wiz = frm;

            prj.CanUpdateVSProject += new CanUpdateVSProjectDelegate(CanGeneratePatternImpl);
            prj.UpdateVSProject += new UpdateVSProjectDelegate(wf_GeneratePattern);
            wiz.WizardWindowClosed += new WizardWindowClosedDelegate(wiz_WizardWindowClosed);
            Application.Run(wiz as Form);
            return 0;
        }

        static void wiz_WizardWindowClosed(object sender, EventWizardWindowClosed evclosed)
        {
            return;
        }

        static void wf_GeneratePattern(object sender, EventGeneration evtg)
        {
            evtg.Result = evtg.LangProvider.IsValidExtension(".*")?ResultEnum.Success:ResultEnum.BadFileExtension;
            
            foreach (var f in evtg.Files)
            {
                string s = f.itemName;
            }
            evtg.ErrorMsg = string.Format("Last Generation result: {0}", evtg.Result);
        }


        static void CanGeneratePatternImpl(object sender, EventValidaton evval)
        {
            
            evval.Result = ResultEnum.Success;
            switch (evval.SelIndex)
            {
                case 2:
                    evval.ErrorMsg = "Some error";
                    evval.Result = evval.LangProvider.IsValidExtension(".*") ? ResultEnum.Success : ResultEnum.BadFileExtension;
                    foreach (var f in evval.Files)
                    {
                        string s = f;
                    }
                    break;
                default:
                    break;
            }
            evval.ErrorMsg = string.Format("Last Generation result: {0}",evval.Result);
            return;
        }

        static void _tabPageSelection_Validating(object sender, CancelEventArgs e)
        {

        }

        static void _tabPageEditPattern_Validating(object sender, CancelEventArgs e)
        {

        }

        static void _tabPageConfirm_Validating(object sender, CancelEventArgs e)
        {

        }
        static void _tabPageSelection_Validated(object sender, EventArgs e)
        {

        }
    }
}
