title Is Visual Studio running?
tasklist | findstr /i devenv.exe
IF %ERRORLEVEL% EQU 0 (
cls
@echo If DesignPatterns solution is opened, it's recommended to close Visual Studio while building
pause
)
title building everything
set "strBuilt=Built:"
set "strSkipped=Skipped:"
set "strPacked=Packed:"
set "strFailed=Failed:"
set "strBuiltTemplates=Built Templates:"
set "strFailedTemplates=Failed Templates:"
cls

title Pre clean and building TemplateLibrary.zip
del /f /q .\..\DesignPatternsAllSetup*.zip
rmdir /s /q .\..\DesignPatternsSetups
mkdir .\..\DesignPatternsSetups
zipdir.exe "..\DesignPatternsSetups\TemplateLibrary.zip" ".\TemplateLibrary"
IF %ERRORLEVEL% NEQ 0 (
@echo Failed tu build ..\DesignPatternsSetups\TemplateLibrary.zip, level = %ERRORLEVEL%
set strFailedTemplates=%strFailedTemplates% TemplateLibrary.zip
) else (
set strBuiltTemplates=%strBuiltTemplates% TemplateLibrary.zip
)
attrib -r ".\TemplateLibrary.zip"
copy /y "..\DesignPatternsSetups\TemplateLibrary.zip" ".\TemplateLibrary.zip"



REG QUERY HKLM\SOFTWARE\Wow6432Node\Microsoft\VisualStudio\12.0\Setup\VS /v environmentpath
IF %ERRORLEVEL% NEQ 0 (
@echo VisualStudio 12.0 is not installed, err level = %ERRORLEVEL%
set strSkipped=%strSkipped% VS2013Bin
) else (
%comspec% /c "vsBuild.bat 2013 12 .\..\ VSEmulator"
IF %ERRORLEVEL% EQU 0 (
set strBuilt=%strBuilt% VS2013Bin
%comspec% /c "buildSetup.bat 2013 12 .\..\ designPatternsSetup"
IF %ERRORLEVEL% EQU 0 (
set strPacked=%strPacked% VS2013Pack
)else (
@echo Failed to pack VisualStudio 2013 add-in err level = %ERRORLEVEL%
set strFailed=%strFailed% VS2013Pack
)
)else (
@echo Failed to build VisualStudio 2013 add-in err level = %ERRORLEVEL%
set strFailed=%strFailed% VS2013Bin
set strSkipped=%strSkipped% VS2013Pack
)
)



REG QUERY HKLM\SOFTWARE\Wow6432Node\Microsoft\VisualStudio\11.0\Setup\VS /v environmentpath
IF %ERRORLEVEL% NEQ 0 (
@echo VisualStudio 11.0 is not installed, err level = %ERRORLEVEL%
set strSkipped=%strSkipped% VS2012Bin
) else (
%comspec% /c "vsBuild.bat 2012 11 .\..\ VSEmulator"
IF %ERRORLEVEL% EQU 0 (
set strBuilt=%strBuilt% VS2012Bin
%comspec% /c "buildSetup.bat 2012 11 .\..\ designPatternsSetup"

IF %ERRORLEVEL% EQU 0 (
set strPacked=%strPacked% VS2012Pack
)else (
@echo Failed to pack VisualStudio 2012 add-in err level = %ERRORLEVEL%
set strFailed=%strFailed% VS2012Pack
)
)else (
@echo Failed to build VisualStudio 2012 add-in err level = %ERRORLEVEL%
set strFailed=%strFailed% VS2012Bin
set strSkipped=%strSkipped% VS2012Pack
)
)


REG QUERY HKLM\SOFTWARE\Wow6432Node\Microsoft\VisualStudio\10.0\Setup\VS /v environmentpath
IF %ERRORLEVEL% NEQ 0 (
@echo VisualStudio 10.0 is not installed, err level = %ERRORLEVEL%
set strSkipped=%strSkipped% VS2010Bin
) else (
%comspec% /c "vsBuild.bat 2010 10 .\..\ designPatternsSetup"
IF %ERRORLEVEL% EQU 0 (
set strBuilt=%strBuilt% VS2010Bin
set strPacked=%strPacked% VS2010Pack
)else (
@echo Failed to build VisualStudio 2010 add-in err level = %ERRORLEVEL%
set strFailed=%strFailed% VS2010All
)
)



REG QUERY HKLM\SOFTWARE\Wow6432Node\Microsoft\VisualStudio\9.0\Setup\VS /v environmentpath
IF %ERRORLEVEL% NEQ 0 (
@echo VisualStudio 9.0 is not installed, err level = %ERRORLEVEL%
set strSkipped=%strSkipped% VS2008Bin
) else (
%comspec% /c "vsBuild.bat 2008 9 .\..\ designPatternsSetup"
IF %ERRORLEVEL% EQU 0 (
set strBuilt=%strBuilt% VS2008Bin
set strPacked=%strPacked% VS2008Pack
)else (
@echo Failed to build VisualStudio 2008 add-in err level = %ERRORLEVEL%
set strFailed=%strFailed% VS2008All
)
)


SET ThisVersion=1.4
title zipping everything for version %ThisVersion%
xcopy /y /i /f Readme.txt .\..\DesignPatternsSetups
xcopy /y /i /f install.bat .\..\DesignPatternsSetups
zipdir ..\DesignPatternsAllSetups_%ThisVersion%.zip .\..\DesignPatternsSetups

rem xcopy /y /i /f .\..\DesignPatternsSetups\TemplateLibrary.zip .\TemplateLibrary.zip

title zipping packages individually
call makeIndividualZip.bat 2008 %ThisVersion%
call makeIndividualZip.bat 2010 %ThisVersion%
call makeIndividualZip.bat 2012 %ThisVersion%
call makeIndividualZip.bat 2013 %ThisVersion%

title cleaning up
rmdir /s /q ..\DesignPatternsSetup_v9\Release
rmdir /s /q ..\DesignPatternsSetup_v9\Debug
rmdir /s /q ..\DesignPatternsSetup_v10\Release
rmdir /s /q ..\DesignPatternsSetup_v10\Debug
rmdir /s /q ..\DesignPatternsSetup_v11\Release
rmdir /s /q ..\DesignPatternsSetup_v11\Debug
del /f /q ..\DesignPatternsSetup_v11\*.exe
del /f /q ..\DesignPatternsSetup_v11\*.dll
del /f /q ..\DesignPatternsSetup_v11\*.Addin
rmdir /s /q ..\DesignPatternsSetup_v12\Release
rmdir /s /q ..\DesignPatternsSetup_v12\Debug
del /f /q ..\DesignPatternsSetup_v12\*.exe
del /f /q ..\DesignPatternsSetup_v12\*.dll
del /f /q ..\DesignPatternsSetup_v12\*.Addin
rmdir /s /q ..\DesignPatterns\obj
rmdir /s /q ..\DesignPatterns\bin
rmdir /s /q ..\DesignPatternsWizard\obj
rmdir /s /q ..\DesignPatternsWizard\bin
rmdir /s /q ..\FormTest\obj
rmdir /s /q ..\FormTest\bin
attrib -h ..\DesignPatterns*.suo /s
del /f /q ..\DesignPatterns*.suo
del /f /q /s .\..\DesignPatternsSetupVS20??.zip

cls
title summary
@echo %strBuilt%
@echo %strSkipped%
@echo %strFailed%
@echo %strPacked%
@echo %strBuiltTemplates%
@echo %strFailedTemplates%

pause
exit /b %ERRORLEVEL%
